﻿
function DbQuery(table, expression) {
    this.table = table;
    this.expr = expression;
}

extend(DbQuery.prototype, function () {
    var countable = {
        lt: true,
        gt: true,
        between: true,
        eq: true
    };

    function iter(query, cb, resolve, reject, idbstore, trans) {
        
    }

    function buildStack(query, cb) {
        var stack = function (cursor, value) {
            cb.call(cursor, value);
            cursor.continue();
        }
        if (query.jsFilter) {
            var filter = function (cursor, value, it, up) {
                if (query.jsFilter)
                    up(cursor, value, it, up.up);
                else
                    cursor.continue();
            }
            filter.up = stack;
        }
        return execStack(stack).then(prevValue);

    }

    return {
        reduce: function(reducerFn, initialVal) {
            var table = db.table(this.table);
            var mode = this.modifyer ? READONLY : READWRITE;
            var query = this;
            if (reducerFn === "count") {
                if (!query.jsFilter && (!query.expr || countable[query.expr[1]]))
                    return pureCount(query, cb, resolve, reject, idbstore);
                reducerFn = function(prev, curr) { return prev + 1; };
                initialVal = 0;
            }
            var result = initialVal;
            return this.iterate(function(val) {
                result = (result === undefined ? val : reducerFn(result, val));
            }).then(function() {
                return result;
            });
        },
        iterate: function (cb) {
            var table = db.table(this.table);
            var mode = this.modifyer ? READONLY : READWRITE;
            var query = this;
            return table._idbstore(mode, function (resolve, reject, idbstore, trans) {
                // Build stack
                var stack = buildStack(query, cb);

                // Iteration
                return iter(query, cb, resolve, reject, idbstore, trans);

            }, !!this.modifyer);
        }
    }
});
