﻿var executeQueryOnIdb = (function() {
    return function(query) {
        
    }

    function getSortedSet(args) {
        return Array.prototype.slice.call(Array.isArray(args[0]) ? args[0] : args).sort(ascending);
    }

    function upperFactory(reversed) {
        return reversed ? function (s) { return s.toLowerCase(); } : function (s) { return s.toUpperCase(); }
    }
    function lowerFactory(reversed) {
        return reversed ? function (s) { return s.toUpperCase(); } : function (s) { return s.toLowerCase(); }
    }

    function nextCasing(key, lowerKey, upperNeedle, lowerNeedle, cmp, reversed) {
        var length = Math.min(key.length, lowerNeedle.length);
        var llp = -1;
        for (var i = 0; i < length; ++i) {
            var lwrKeyChar = lowerKey[i];
            if (lwrKeyChar !== lowerNeedle[i]) {
                if (cmp(key[i], upperNeedle[i]) < 0) return key.substr(0, i) + upperNeedle[i] + upperNeedle.substr(i + 1);
                if (cmp(key[i], lowerNeedle[i]) < 0) return key.substr(0, i) + lowerNeedle[i] + upperNeedle.substr(i + 1);
                if (llp >= 0) return key.substr(0, llp) + lowerKey[llp] + upperNeedle.substr(llp + 1);
                return null;
            }
            if (cmp(key[i], lwrKeyChar) < 0) llp = i;
        }
        if (length < lowerNeedle.length && !reversed) return key + upperNeedle.substr(key.length);
        if (length < key.length && reversed) return key.substr(0, upperNeedle.length);
        return (llp < 0 ? null : key.substr(0, llp) + lowerNeedle[llp] + upperNeedle.substr(llp + 1));
    }

    function createIgnoreCaseFilter(c, match, needle) {
        /// <param name="needle" type="String"></param>
        return function (reversed) {
            var upper = upperFactory(reversed),
                lower = lowerFactory(reversed),
                compare = (reversed ? descending : ascending),
                upperNeedle = upper(needle),
                lowerNeedle = lower(needle);

            return function (cursor, value, it, up) {
                /// <param name="cursor" type="IDBCursor"></param>
                var key = cursor.key;
                if (typeof key !== 'string') return cursor.continue();
                var lowerKey = lower(key);
                if (match(lowerKey, lowerNeedle)) {
                    up(cursor, value, it, up.up);
                } else {
                    var nextNeedle = nextCasing(key, lowerKey, upperNeedle, lowerNeedle, compare, reversed);
                    if (nextNeedle)
                        cursor.continue(nextNeedle);
                    else
                        it.resolve();
                }
            };
        };
    }


});